; macro57.inc
;Write by NickF 02.11.2015 
;Rewrite 27.11.2015
;********************************
;  "fl_rej"     
;********************************
inv_bit_fl	MACRO
		rejfla
		xorwf	fl_rej,f	;  
		ENDM
;********************************
;  "rejim"  "n" 
;   "jmp"   
;********************************
comreg	MACRO	n,reg,jmp
		movfw	reg
		sublw	n
		skpz
		goto	jmp
		ENDM
;**********************************
;   "var"
;**********************************
combit	MACRO	n1,var,jmp
		btfss	var,n1		;  
		goto	jmp			;   
		ENDM
;***********************************************
;     
;*************************************
Umax	MACRO	Uz,Nadc,jmp1,jmp2
		movlw	Uz			; ,  .   
		subwf	Nadc,w		; .     
;  .  
		skpc				;NumH  ?
		goto	jmp1		;,   
		skpnz
		goto	jmp2		;,    . 
		call	Zero_Cur
		goto	jmp1	
		ENDM
;**********************************
;     
;*************************************
Umin	MACRO	Up,Nadc,jmp1,jmp2
	local	jp
		movlw	Up			; ,  .   
		subwf	Nadc,w		; .     
;  .  
		skpc				;NumH  ?
		goto	jp		;,    
		skpnz
		goto	jmp1	;.    .   
;   . 
		goto	jmp2
jp		call	Zero_Cur
		goto	jmp2	
			ENDM
;=========================================
;=============================================
;   / 
;=============================================
mul		MACRO	t,nc,rn
	local	lo
		movfw	t
		movwf	t_nk
		movlw	nc
		movwf	count
		movfw	NumL
lo		rrf		t_nk,f
		skpnc
		addwf	r2,f
		rrf		r2,f
		rrf		rn,f
		decfsz	count,f
		goto	lo	
		ENDM
;==============================================
; 256 * "nd" = uS
;==============================================
Delay	MACRO	nT1
	local	te1
		movlw	nT1
		movwf	TEMP1
te1		clrw
		call	Pause
		decfsz	TEMP1,f
		goto	te1
		ENDM
;====================================================
;     
;====================================================
rejfla	MACRO	
	local lp
		movfw	rejim	;    
		movwf	count	;W -> count
		incf	count,f	;count = count + 1
		clrf	t_nk		
		setc			;set CARRY to "1"
lp		rlf		t_nk,f
		decfsz	count,f
		goto	lp
		movfw	t_nk		
;    / 
		ENDM
;====================================================
;  0/1      
;====================================================
rej_bit	MACRO	num,jmp1,jmp2
	comreg	num,rejim,jmp1		; "jmp1"
;num = rejim
	combit	num,fl_rej,jmp2	;  "0",  "jmp2" 
;  "1" 
		ENDM
;********************************
;  "rejim"  "n" 
;   "jmp"   
;********************************
_comreg	MACRO	n,reg,jmp
		movfw	reg
		sublw	n
		skpnz
		goto	jmp
		ENDM
;===================================================
